#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <iostream>
#include <string>

using namespace std;

int main ()
{
    int sock;
    sockaddr_in addr, client_addr;
    socklen_t size;
    char buf[100];

    sock = socket (PF_INET, SOCK_DGRAM, 0);
    if (sock == -1) perror ("socket");

    memset (&addr, 0, sizeof (addr));
    memset (&client_addr, 0, sizeof (addr));

    client_addr.sin_family = PF_INET;
    addr.sin_family = PF_INET;
    addr.sin_port = htons (9000);
    addr.sin_addr.s_addr = htonl (INADDR_ANY);

    if (bind (sock, (struct sockaddr *) &addr, sizeof (struct sockaddr)))
        perror ("Funkcja bind");

    struct ip_mreq group;
    group.imr_interface.s_addr = INADDR_ANY;
    group.imr_multiaddr.s_addr = inet_addr ("224.0.0.1");

    int setret = setsockopt (sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, &group, sizeof (struct ip_mreq));
    if (setret == -1) perror ("setsockopt");

    size = sizeof (struct sockaddr);
    int r = recvfrom (sock, buf, 100, 0, (struct sockaddr *) &client_addr, &size);
    if (r < 0) perror ("Funkcja recvfrom");
    buf[r-1] = '\0';
    cout << "Odebrano od klienta " << r << " znakow: " << buf << endl;
    cout << "Port: " << ntohs (client_addr.sin_port) << " adres: " << inet_ntoa (client_addr.sin_addr) << endl;

    return 0;
}
